'use strict';
const express = require('express')
let request = require('request')
const process = require('process')

const dgram = require('dgram');
const { constants } = require('buffer');
const { spawnSync, execSync } = require('child_process');
// const { logger } = require('../../lib');
const server = dgram.createSocket('udp4');
const udpProxy = dgram.createSocket('udp4');
const os = require('os')
let struct = require('jspack')
struct = struct.jspack


const app = express()
let port = 5000, resource_id, functionHash, runtime, idleTime = 300, flagFirstRequest = true
let waitTime

resource_id = process.argv[2]
functionHash = process.argv[3]
port = process.argv[4]
runtime = process.argv[5]
request = request.defaults({
    headers: { 'x-resource-id': resource_id }
});
let lastRequest = Date.now(), totalRequest = 0


async function executor(payload) {
    return new Promise((resolve, reject) => {
        console.log("executor")
    })
}

server.on('error', (err) => {
    console.log(`server error:\n${err.stack}`);
    server.close();
});

function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

server.on('message', (msg, rinfo) => {
    console.log("message", msg)
    let payload = unpackPacket(msg)
    console.log(payload, typeof payload);
    lastRequest = Date.now()
    console.log("network stack time", lastRequest - payload.t1)
    totalRequest++
    executor(msg).then(result => {
        result = packPacket(msg)
        let port = 10000 + getRandomInt(0, 10)
        try {
            udpProxy.send(msg, 0, msg.length, port, rinfo.address, function (err, bytes) {
                if (err)
                    console.log(err)
                console.log("response via UDP")
            })
        } catch (e) {
            console.log(e)
        }

    })
});

function unpackPacket(packet) {
    // let buffer = new Array(1024)
    let chain_id = null, exec_id = null, function_count = null, function_id = null, data = null
    let base = 0, f0, f1, f2, f3, f4, t1, t2, t3, t4
    chain_id = struct.Unpack(">I", packet, base)
    base += 4
    exec_id = struct.Unpack(">I", packet, base)
    base += 4
    function_id = struct.Unpack(">I", packet, base)
    base += 4
    data = struct.Unpack(">I", packet, base)
    base += 4
    function_count = struct.Unpack("I", packet, base)
    base += 4

    f0 = struct.Unpack("B", packet, base)
    base += 1
    f1 = struct.Unpack("B", packet, base)
    base += 1
    f2 = struct.Unpack("B", packet, base)
    base += 1
    f3 = struct.Unpack("B", packet, base)
    base += 1
    f4 = struct.Unpack("B", packet, base)
    base += 1

    t1 = struct.Unpack("I", packet, base)
    base += 8
    t2 = struct.Unpack("I", packet, base)
    base += 8
    t3 = struct.Unpack("I", packet, base)
    base += 8
    t4 = struct.Unpack("I", packet, base)


    console.log("chain_id", chain_id, "exec_id", exec_id, "data", data, "function_count", function_count, "function_id", function_id)


    return {
        chain_id: chain_id[0],
        exec_id: exec_id[0],
        data: data[0],
        function_count: function_count[0],
        function_id: function_id[0],
        f0, f1, f2, f3, f4, t1, t2, t3, t4
    }
}

function packPacket(dataPacket) {

    let message = new Array(1024)
    let base = 0, chain_id, exec_id, function_id, data, function_count
    chain_id = struct.PackTo(">I", message, base, [dataPacket.chain_id])
    base += 4
    exec_id = struct.PackTo(">I", message, base, [dataPacket.exec_id])
    base += 4
    function_id = struct.PackTo(">I", message, base, [dataPacket.function_id])
    base += 4
    data = struct.PackTo(">I", message, base, [dataPacket.data])
    base += 4
    function_count = struct.PackTo("B", message, base, [dataPacket.function_count])
    message = Buffer.from(message)
    return message
}


server.on('listening', () => {
    const address = server.address();
    console.log(`server listening ${address.address}:${address.port}`);
});

// server.bind(port, "192.168.2.3");
// server.bind(port);
server.bind(port);
console.log("bind to port", port);

setInterval(shouldDie, 1000);
